/*
 * Popolon.cpp
 *
 *  Created on: Oct 2, 2008
 *      Author: Santi Ontan
 */

#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif

#ifdef _WIN32
#include <windows.h>
#endif


#include "debug.h"

#include "Popolon.h"

#include "KObjectCreator.h"

Popolon::Popolon(int x,int y,int sfx_volume,GLTManager *GLTM,SFXManager *SFXM,int ID) : KPlayer(x,y,sfx_volume,ID) {
	m_class = popolon_symbol;
	m_move_speed = 2.5f;
	m_weapon = WEAPON_ARROW;
	m_weapon_count = 0;
	
	m_shadow_tile = GLTM->get("popolon-shadow");

	// Create the animations for the different states (check KPlayer.h to see the states available
	Animation *a = new Animation(true,SFXM);
	a->addFrame(GLTM->get("popolon_walking_000001"),8,"sfx/player_step1",sfx_volume);
	a->addFrame(GLTM->get("popolon_walking_000002"),8);
	a->addFrame(GLTM->get("popolon_walking_000003"),8);
	a->addFrame(GLTM->get("popolon_walking_000004"),8,"sfx/player_step2",sfx_volume);
	a->addFrame(GLTM->get("popolon_walking_000005"),8);
	a->addFrame(GLTM->get("popolon_walking_000006"),8);
	m_state_animations[PLAYER_STATE_IDLE]=a;

	a = new Animation(true,SFXM);
	a->addFrame(GLTM->get("popolon_walking_000001"),4,"sfx/player_step1",sfx_volume);
	a->addFrame(GLTM->get("popolon_walking_000002"),4);
	a->addFrame(GLTM->get("popolon_walking_000003"),4);
	a->addFrame(GLTM->get("popolon_walking_000004"),4,"sfx/player_step2",sfx_volume);
	a->addFrame(GLTM->get("popolon_walking_000005"),4);
	a->addFrame(GLTM->get("popolon_walking_000006"),4);
	m_state_animations[PLAYER_STATE_WALKING]=a;

	m_state = PLAYER_STATE_IDLE;

	output_debug_message("Popolon created.\n");
}

Popolon::~Popolon() {
}



bool Popolon::is_a(Symbol *c)
{
    if (c->cmp(popolon_symbol))
        return true;

    return KPlayer::is_a(c);
} /* Popolon::is_a */


bool Popolon::is_a(char *c)
{
    bool retval;
    Symbol *s = new Symbol(c);

    retval = is_a(s);

    delete s;

    return retval;
} /* Popolon::is_a */
