#ifdef KITSCHY_DEBUG_MEMORY
#include "debug_memorymanager.h"
#endif

#ifdef _WIN32
#include "windows.h"
#endif

#include "stdio.h"
#include "math.h"
#include "stdlib.h"
#include "string.h"

#include "debug.h"

#include "GL/gl.h"
#include "SDL.h"
#include "SDL_mixer.h"

#include "BList.h"
#include "Symbol.h"
#include "2DCMC.h"
#include "auxiliar.h"
#include "GLTile.h"
#include "2DCMC.h"
#include "keyboardstate.h"
#include "randomc.h"
#include "VirtualController.h"

#include "GLTManager.h"
#include "SoundManager.h"
#include "SFXManager.h"
#include "MusicManager.h"
#include "KObject.h"
#include "Knightmare.h"
#include "KnightmareApp.h"

// #include "font_extractor.h"


int KnightmareApp::game_cycle(KEYBOARDSTATE *k)
{
	if (k->key_press(SDLK_ESCAPE)) {
		m_MusicM->music_fadeout(0,50);
		return STATE_KONAMI;
	}

	if (m_state_cycle==0) {
		m_MusicM->music_play(0, "level1", m_music_volume,-1);
	}

	{
		VirtualController *vc;
		m_vc_l.Rewind();
		while(m_vc_l.Iterate(vc)) {
			vc->new_cycle();
			vc->m_keyboardstate = k;
			if (vc->m_ID==0) {
				if (k->key_pressed(m_keys_configuration1[KKEY_UP])) vc->m_joystick[VC_UP]=true;
				if (k->key_pressed(m_keys_configuration1[KKEY_DOWN])) vc->m_joystick[VC_DOWN]=true;
				if (k->key_pressed(m_keys_configuration1[KKEY_LEFT])) vc->m_joystick[VC_LEFT]=true;
				if (k->key_pressed(m_keys_configuration1[KKEY_RIGHT])) vc->m_joystick[VC_RIGHT]=true;
				if (k->key_pressed(m_keys_configuration1[KKEY_FIRE])) vc->m_button[0]=true;
			}
			if (vc->m_ID==1) {
				if (k->key_pressed(m_keys_configuration2[KKEY_UP])) vc->m_joystick[VC_UP]=true;
				if (k->key_pressed(m_keys_configuration2[KKEY_DOWN])) vc->m_joystick[VC_DOWN]=true;
				if (k->key_pressed(m_keys_configuration2[KKEY_LEFT])) vc->m_joystick[VC_LEFT]=true;
				if (k->key_pressed(m_keys_configuration2[KKEY_RIGHT])) vc->m_joystick[VC_RIGHT]=true;
				if (k->key_pressed(m_keys_configuration2[KKEY_FIRE])) vc->m_button[0]=true;
			}
			
			// Prevent firing arrows because of the key press to start the game:
			if (m_state_cycle==0) {
				vc->m_old_button[0]=vc->m_button[0];
				vc->m_old_button[1]=vc->m_button[1];
			}
		}
	}

	m_game->cycle(&m_vc_l,m_GLTM,m_SFXM,m_MusicM);

    return STATE_GAME;
}

void KnightmareApp::game_draw(void)
{
	glClearColor(0, 0, 0, 1);
    glClear(GL_COLOR_BUFFER_BIT|GL_DEPTH_BUFFER_BIT|GL_STENCIL_BUFFER_BIT);

    m_game->draw(m_GLTM);
}

